class _neg1 { public: static const int as_int = -1; };
class _0 { public: static const int as_int = 0; };
class _1 { public: static const int as_int = 1; };
class _2 { public: static const int as_int = 2; };
class _3 { public: static const int as_int = 3; };
class _4 { public: static const int as_int = 4; };

template <class x> class _raw_incr;
class _raw_incr<_0> { public: typedef _1 t; };
class _raw_incr<_1> { public: typedef _2 t; };
class _raw_incr<_2> { public: typedef _3 t; };
class _raw_incr<_3> { public: typedef _4 t; };
#define _incr(x) typename _raw_incr<x>::t

template <class x> class _raw_decr;
class _raw_decr<_0> { public: typedef _neg1 t; };
class _raw_decr<_1> { public: typedef _0 t; };
class _raw_decr<_2> { public: typedef _1 t; };
class _raw_decr<_3> { public: typedef _2 t; };
class _raw_decr<_4> { public: typedef _3 t; };
#define _decr(x) typename _raw_decr<x>::t

template <class x, class y>
class _raw_plus;
template <class x>
class _raw_plus<x,_0> { public: typedef x t; };
template <class x>
class _raw_plus<_0,x> { public: typedef x t; };
template <class x, class y>
class _raw_plus {
public:
    typedef typename _raw_plus< _incr(x), _decr(y) >::t t;
};
#define _plus(x,y) typename _raw_plus<x,y>::t

template <class x, class y>
class _raw_minus;
template <class x>
class _raw_minus<x,_0> { public: typedef x t; };
template <class x, class y>
class _raw_minus {
public:
    typedef typename _raw_minus< _decr(x), _decr(y) >::t t;
};
#define _minus(x,y) typename _raw_minus<x,y>::t
