
template<class BASE>
class dense_vector :
    public term_nesting< dense_vector<BASE>, _1, interval_iterator, term_scalar<BASE> >
{
protected:
    typedef term_nesting< dense_vector<BASE>, _1, interval_iterator, term_scalar<BASE> >
    base_term_type;
public:
    typedef typename base_term_type::iterator_type iterator_type;
    typedef typename base_term_type::subterm_type subterm_type;
    typedef typename base_term_type::key_type key_type;
public:
    BASE * bsp_restrict storage;
    int lb;
    dense_vector(int n, BASE *storage, int lb = 0)
	: base_term_type(tuple<_1>(n)),
	  storage(storage), lb(lb) { }
    ~dense_vector() { }
    iterator_type v_tn_begin() const { return interval_iterator(0); }
    iterator_type v_tn_end() const { return interval_iterator(size());; }
    subterm_type v_tn_subterm(iterator_type it)
	{ return storage[lb+*it]; }
};
